@code

#include "mbed.h"
#include "N5110.h"
#include "Gamepad.h"
#include "explorer.h"
#include <cstdlib>
#include <ctime>

Gamepad gamepad;
N5110 lcd(PTC9,PTC0,PTC7,PTD2,PTD1,PTC11);
Explorer _player;

int _player_x; 
int _player_y;
int _level;
bool _f_flag;
bool _r_flag;
int _speed;
int _jump_height;
Player_direction _player_direction;
explorer_sprite _sprite  

int main() {
  _f_flag = false;
  _player_direction = right;
  _r_flag = false;
  _speed = 0;//the player is standing at first
  _jump_height = 30;
  while(1) {
    
    // Y coordinate
    _player.set_y_coordinate(false, _jump_height, _level);  
    _f_flag = _player._f_flag(); 
    _player_y = _player.get_y_();
    _jump_height = _player.get_jump_height();
    
    // X coordinate
    _player_x = _player.get_x();
    _speed = player.get_speed(); 
    _player.set_x_coordinate(rand()%90, _speed, _player_direction); 
 
        
    //change in to a new direction.
    _player_direction = _player.get_direction();
    
     if (_f_flag) 
    {
      _player.fall(_f_flag, gamepad);
    } 
    
    lcd.drawSprite(_player_x,_player_y,23,15,(int *)_player.get_sprite(_sprite));//draw the place where the player first located 
  }  
}
    
@endcode
*/